VERSION 5.00
Object = "{0E59F1D2-1FBE-11D0-8FF2-00A0D10038BC}#1.0#0"; "MSSCRIPT.OCX"
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form MainForm 
   BorderStyle     =   1  'Fixed Single
   Caption         =   ""
   ClientHeight    =   1950
   ClientLeft      =   3675
   ClientTop       =   2415
   ClientWidth     =   5670
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   9.75
      Charset         =   204
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "station.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   1950
   ScaleWidth      =   5670
   StartUpPosition =   2  'CenterScreen
   Begin MSScriptControlCtl.ScriptControl ctrlScript 
      Left            =   3600
      Top             =   -120
      _ExtentX        =   1005
      _ExtentY        =   1005
      AllowUI         =   -1  'True
   End
   Begin VB.TextBox TextRecvStr 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1455
      Left            =   15
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      Top             =   480
      Width           =   5655
   End
   Begin MSCommLib.MSComm CommPort 
      Left            =   4560
      Top             =   -120
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      Handshaking     =   2
      RTSEnable       =   -1  'True
      BaudRate        =   300
      StopBits        =   2
   End
   Begin VB.Label lblNumberCall 
      Caption         =   "0"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   2040
      TabIndex        =   1
      Top             =   120
      Width           =   495
   End
   Begin VB.Label lblResultCall 
      Caption         =   " "
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   204
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1815
   End
   Begin VB.Menu mnuQuit 
      Caption         =   "&"
   End
   Begin VB.Menu About 
      Caption         =   "& "
   End
   Begin VB.Menu Help 
      Caption         =   "&?"
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Compare Binary
Dim strBuffer As String '       
Dim strDelimiter As String '  
Dim ADORecordData As New ADODB.Recordset '      
Dim ADOConnection As New ADODB.Connection '      
Dim bOutErrorToLog As Boolean '    -
Dim bValidInit As Boolean

Private Sub About_Click()
Dim frm As Form
   Set frm = New frmAbout
   frm.Show vbModal, Me
End Sub


'   
'    CommPort.CommPort = 2 '  
'    CommPort.Settings = "300,N,8,2" ' 
'    CommPort.Handshaking = comRTS

Private Sub CommPort_OnComm()
Dim strTemp As String
Dim iPosChr As Integer
Dim bResult As Boolean
Dim iErrCode As Integer

    Select Case CommPort.CommEvent
    ' Handle each event or error by placing
    ' code below each case statement

    ' Errors
        Case comEventBreak  ' A Break was received.
        Case comEventCDTO   ' CD (RLSD) Timeout.
        Case comEventCTSTO  ' CTS Timeout.
        Case comEventDSRTO  ' DSR Timeout.
        Case comEventFrame  ' Framing Error
        Case comEventOverrun    ' Data Lost.
        Case comEventRxOver ' Receive buffer overflow.
        Case comEventRxParity   ' Parity Error.

        Case comEventTxFull ' Transmit buffer full.
        Case comEventDCB    ' Unexpected error retrieving DCB]
        
        Case comEvReceive '     
        '   ,      ,  
            strBuffer = strBuffer + CommPort.Input '     
            Do
                strTemp = GetFirstParam(strBuffer, vbLf, bResult)
                If Not bResult Then Exit Sub '    -   
                If InStr(strTemp, vbCr) > 0 Then strTemp = Left(strTemp, InStr(strTemp, vbCr) - 1) '     
                '        
                AddStrToFile strFileLogName, AnsiToOem(strTemp), iErrCode '    
                If bValidInit Then
                    If Not AddRecord(strTemp) And bOutErrorToLog Then
                        strTemp = ":    - " & strTemp
                        AddStrToFile strFileLogName, AnsiToOem(strTemp), iErrCode '    
                    End If
                End If
                DisplayText (strTemp) '   
                Loop While bResult '  
          End Select

End Sub

Private Sub Form_Load()
Dim iErrCode  As Integer
Dim strTemp As String

    bValidInit = Initialize
    SetTrayIcon NIM_ADD, Me.hwnd, Me.Icon, ""
    
    '   
On Error GoTo Err_Init
     strErrorMsg = "  !"
     CommPort.PortOpen = True '  

    CommPort.DTREnable = True '   
    CommPort.RThreshold = 1 '    1 
    Me.WindowState = vbMinimized
    Me.Hide
    
    strTemp = "Start at " & Format(Now(), "dd\/mm\/yyyy hh:nn:ss")
    AddStrToFile strFileLogName, strTemp, iErrCode '    
    Exit Sub

Err_Init:
    MsgBox strErrorMsg, vbOKOnly + vbCritical, " !"
    Err.Clear
    bValidInit = False
End Sub



Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim Msg As Variant
Dim strTemp As String
    Msg = X / Screen.TwipsPerPixelX
    If Msg = WM_LBUTTONDBLCLK Then
        Me.Visible = Not Me.Visible
        If Not Me.Visible Then Me.WindowState = vbMinimized
        End If
    End Sub




Private Sub Form_Unload(Cancel As Integer)
Dim iErrCode  As Integer
Dim strTemp As String '  ,      

On Error Resume Next  '   -   
  'SetHook Me.hwnd, lpPrevWndProc '   
  ADORecordData.Close '   
  ADOConnection.Close ' 
  ctrlScript.Reset    '  
  If CommPort.PortOpen Then
    CommPort.PortOpen = False
    End If
  strTemp = "Stop  at " & Format(Now(), "dd\/mm\/yyyy hh:nn:ss")
  AddStrToFile strFileLogName, strTemp, iErrCode '    
  SetTrayIcon NIM_DELETE, Me.hwnd, 0&, "" '    
  
  End Sub

Private Sub Help_Click()
    SendKeys "{F1}"
End Sub

Private Sub mnuQuit_Click()
    Unload Me
    End Sub

Private Function Initialize() As Boolean  '  
Dim strTemp As String
Dim strBuff As String
Dim iCount As Integer
Dim iBuff As Byte
Dim bRes As Boolean
On Error Resume Next

     bRes = True
     strFileLogName = ""
    '
   ' If Date > DateSerial(2001, 7, 31) Then
      '  MsgBox "   !   !", vbCritical + vbOKOnly, ""
       ' DisplayText ("   !   !")
       ' Initialize = False
      '  Exit Function
   ' End If
    
    GetBaseExeName strTemp, strStartDirPath
    strFileLogName = strTemp + "Log"
    strFileScriptName = strTemp + "Bas"
    strBuffer = "" '   
       
    '   
    
    Err.Clear
    iCount = FreeFile()
    strTemp = ""
    Open strFileScriptName For Binary Shared As #iCount
    If Err.Number <> 0 Then
        DisplayText ("    : " & strFileScriptName)
        Err.Clear
        bRes = False
        End If
    
    
    While Not EOF(iCount)
        Get #iCount, , iBuff
        If Chr(iBuff) <> vbCr And _
            Chr(iBuff) <> vbLf Then strBuff = strBuff & Chr(iBuff)
        If Chr(iBuff) = vbLf Then
            Trim (strBuff)
            If (strBuff <> "") And _
                (InStr(strBuff, ";") <> 1) And _
                (InStr(1, strBuff, "REM ", vbTextCompare) <> 1) Then strTemp = strTemp & strBuff & vbCrLf
            strBuff = ""
        End If
    Wend
    Close #iCount
    
    ctrlScript.AddCode strTemp
    If Err.Number <> 0 Then
        DisplayText ("   : " & strFileScriptName)
        Err.Clear
        bRes = False
    End If
    
    strTemp = ""
  
    '     
    strDataLinkName = ctrlScript.Run("GetDataLinkPath")
    If Err.Number <> 0 Then
        DisplayText ("   GetDataLinkPath")
        Err.Clear
        bRes = False
    End If
    
        
    '   
    strTableName = ctrlScript.Run("GetTableName")
    If Err.Number <> 0 Then
        DisplayText ("   GetTableName")
        Err.Clear
        bRes = False
    End If
    ADOConnection.ConnectionString = "File Name=" & strDataLinkName & ";"
    ADOConnection.Open '     
    If Err.Number <> 0 Then
        DisplayText ("     ")
        Err.Clear
        bRes = False
    End If
    ADORecordData.Open strTableName, ADOConnection, adOpenKeyset, adLockOptimistic, adCmdTable
    If Err.Number <> 0 Then
        DisplayText ("   : " & strTableName)
        Err.Clear
        bRes = False
    End If
    
    CommPort.CommPort = ctrlScript.Run("GetCommNumber") '  
    If Err.Number <> 0 Then
        DisplayText ("   GetCommNumber")
        Err.Clear
        bRes = False
    End If
    
    CommPort.Settings = ctrlScript.Run("GetCommSettings") ' 
    If Err.Number <> 0 Then
        DisplayText ("   GetCommSettings")
        Err.Clear
        bRes = False
    End If
    
    CommPort.Handshaking = ctrlScript.Run("GetCommHandshaking") '    
    If Err.Number <> 0 Then
        DisplayText ("   GetCommHandshaking")
        Err.Clear
        bRes = False
    End If

    CommPort.InputLen = 0 '     
    
    
    strTemp = ctrlScript.Run("GetLogFileName") '  -
    If Err.Number <> 0 Then
        Err.Clear
    Else
    strFileLogName = strTemp
    End If
    bOutErrorToLog = ctrlScript.Run("OutErrorToLog") '     -
    If Err.Number <> 0 Then
        bOutErrorToLog = False
        Err.Clear
    End If
        
    
    Initialize = bRes
    DisplayText (" : " & strFileIniName)
    DisplayText (" : " & strFileLogName)
    DisplayText ("   : " & strDataLinkName)
    DisplayText (" : " & CStr(CommPort.CommPort))
    DisplayText (" : " & CommPort.Settings)
    End Function


Public Function AddRecord(strLine As String) As Boolean
'  :
'     ,        
'    ,      
'   

Dim fld As ADODB.Field
Dim bUpdate As Boolean '  ,     (     )
Dim vTemp As Variant

    AddRecord = False
    ADORecordData.AddNew
    On Error GoTo Err_AddData
    bUpdate = False
    For Each fld In ADORecordData.Fields    '       
        If Not IsProcedureFound(fld.Name) Then GoTo NextStep '       
        vTemp = ctrlScript.Run(fld.Name, strLine)
        Select Case fld.Type
            Case adDate, adDBTime, adDBDate, adDBTimeStamp '    
                If Not IsDate(vTemp) Then
                    DisplayText (":    " & fld.Name & ".  " & CStr(vTemp) & "   /.")  '  
                    GoTo Label_FastExit '    
                End If 'If Not IsDate(strBuff)
                    
                '    -   
                Case adTinyInt, adSmallInt, adInteger, adSingle, adBigInt, _
                    adCurrency, adDecimal, adDouble, adNumeric
                    If Not IsNumeric(vTemp) Then
                        DisplayText (":    " & fld.Name & ".  " & CStr(vTemp) & "   .")  '  
                        GoTo Label_FastExit
                        End If 'If Not IsNumeric(strBuff)
                        
                End Select
            fld.Value = vTemp
            bUpdate = True
NextStep:
        Next 'For Each fld
    If bUpdate Then
        ADORecordData.Update
        AddRecord = True
        Else '        -   
        ADORecordData.CancelUpdate
        End If 'If bUpdate
    
    Me.lblNumberCall.Caption = Str(Val(Me.lblNumberCall.Caption) + 1)
    Exit Function
Err_AddData: '  (  )
    DisplayText (":     !  : " & Err.Number) '  
    Err.Clear
Label_FastExit:
    ADORecordData.CancelUpdate '     
    End Function

'   textbox
Public Sub DisplayText(strMsg As String)
Dim strBuff As String
Dim iPos As Integer
    If Len(TextRecvStr.Text) > 10240 Then '     10Kb   
        strBuff = Right(TextRecvStr.Text, 10240) '  10Kb,       - 
        iPos = InStr(strBuff, vbLf) '     
        If iPos > 0 Then strBuff = Right(strBuff, Len(strBuff) - iPos)
        TextRecvStr.Text = strBuff & strMsg & vbCrLf '  
        Else
        TextRecvStr.Text = TextRecvStr.Text & strMsg & vbCrLf '  
        End If 'If Len(TextRecvStr.Text) > 10240
        TextRecvStr.SelStart = Len(TextRecvStr.Text)
End Sub


'        

Private Function IsProcedureFound(strNameProc As String) As Boolean
Dim prTemp As Procedure
    IsProcedureFound = False
    For Each prTemp In ctrlScript.Procedures
        If UCase(prTemp.Name) = UCase(strNameProc) Then
            IsProcedureFound = True
            Exit Function
        End If
    Next prTemp
End Function
